import wx
from BusyAnimation import BusyAnimation
from time import sleep

class Demo(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, -1, "BusyAnimation Demonstration", size=(320, 450))
        self.SetBackgroundColour("grey80")
        txt = wx.StaticText(self, -1, "Testing 1 2 3 ....", pos=(20, 20))
        self.sbutton = wx.Button(self, -1, label='Load Busy', pos=(20, 60))
        self.Bind(wx.EVT_BUTTON, self.OnStart, self.sbutton)
        self.Bind(wx.EVT_CLOSE, self.OnQuit)
        self.Show()

    def OnStart(self, event):
        self.sbutton.Disable()

        # a busy animation that will run for 10 seconds and then cancel itself using a gif file
        #bmp1 = wx.Image('circular1.png')
        #bmp1 = bmp1.Rescale(48,48,wx.IMAGE_QUALITY_HIGH)
        #bmp2 = wx.Image('circular2.png')
        #bmp2 = bmp2.Rescale(48,48,wx.IMAGE_QUALITY_HIGH)

        self.busy = BusyAnimation(self, wx.ID_ANY, title="Busy", size = (260, 260), msg="Processing...", \
                                images = ['321.gif',], \
                                #images = [wx.Bitmap(bmp1), wx.Bitmap(bmp2),],
                                speed=250, elapse=1, timer = 10, pid_lock=-1)
        wx.GetApp().Yield()
        cnt = 0
        while cnt < 10: # Perform some other long running task, here a simple series of sleep is used
            if not self.busy.IsRunning(): # Busy can be cancelled by clicking Frame Close
                break
            sleep(.1)
            cnt += .1
            wx.GetApp().Yield()
        try:
            self.sbutton.Enable()
        except Exception:
            pass

    def OnQuit(self, event):
        try:
            if self.busy.IsRunning():
                self.busy.Stop()
        except Exception:
            pass
        self.Destroy()


if __name__ == '__main__':
    app = wx.App()
    frame = Demo(None)
    app.MainLoop()
