import wx
from BusyAnimation import BusyAnimation
from time import sleep

class Demo(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, -1, "BusyAnimation Demonstration", size=(320, 450))
        self.SetBackgroundColour("grey80")
        txt = wx.StaticText(self, -1, "Testing 1 2 3 ....", pos=(20, 20))
        self.sbutton = wx.Button(self, -1, label='Load Busy', pos=(20, 60), size=(100, 35))
        self.ebutton = wx.Button(self, -1, label='End  Busy', pos=(20, 100), size=(100, 35))
        self.Bind(wx.EVT_BUTTON, self.OnStart, self.sbutton)
        self.Bind(wx.EVT_BUTTON, self.OnEnd, self.ebutton)
        self.Bind(wx.EVT_CLOSE, self.OnQuit)
        self.Run = True
        self.ebutton.Disable()
        self.Show()

    def OnStart(self, event):
        self.sbutton.Disable()
        self.ebutton.Enable()
        # a busy animation that will run until stopped using a list of images

        self.busy = BusyAnimation(self, wx.ID_ANY, title="Busy", size = (260, 260), msg="Processing...", \
                             images = [wx.Bitmap('1.png'),wx.Bitmap('2.png'),wx.Bitmap('3.png'),wx.Bitmap('4.png'),], \
                             speed=200, elapse=0, timer = -1, pid_lock=-1)
        wx.GetApp().Yield()
        while self.Run: # Perform some other long running task, here a simple series of sleep is used
            if not self.busy.IsRunning(): # Busy can be cancelled by clicking Frame Close
                break
            sleep(.5)
            wx.GetApp().Yield()

        self.Run = True
        try:
            self.ebutton.Disable()
            self.sbutton.Enable()
        except Exception:
            pass

    def OnEnd(self, event):
        self.Run = False
        self.busy.Stop()
        self.sbutton.Enable()
        self.ebutton.Disable()

    def OnQuit(self, event):
        try:
            if self.busy.IsRunning():
                self.busy.Stop()
        except Exception:
            pass
        self.Destroy()


if __name__ == '__main__':
    app = wx.App()
    frame = Demo(None)
    app.MainLoop()
