import wx
from subprocess import Popen
import sys, os, signal

class Demo(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, -1, "BusyAnimation Demonstration", size=(320, 450))
        self.SetBackgroundColour("grey80")
        txt = wx.StaticText(self, -1, "Run Busy in a separate process ....", pos=(20, 20))
        self.sbutton = wx.Button(self, -1, label='Load Busy', pos=(20, 60))
        self.Bind(wx.EVT_BUTTON, self.OnStart, self.sbutton)
        self.Bind(wx.EVT_CLOSE, self.OnQuit)
        self.Show()
        self.proc = None

    def OnStart(self, event):
        self.proc = Popen([sys.executable, 'BusyAnimation.py', 'loading.gif', '100', '2', '65', '-1'],).pid

    def OnQuit(self, event):
        try:
            if self.proc:
                os.kill(self.proc, signal.SIGTERM)
        except Exception as e:
            print(str(e))
        self.Destroy()


if __name__ == '__main__':
    app = wx.App()
    frame = Demo(None)
    app.MainLoop()
