import wx
from subprocess import Popen
import sys

class Demo(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, -1, "BusyAnimation Demonstration", size=(400, 300))
        self.SetBackgroundColour("grey80")
        txt1 = wx.StaticText(self, -1, "Run Busy in a separate process ....", pos=(20, 20))
        txt2 = wx.StaticText(self, -1, "You may destroy this frame, leaving Busy running", pos=(20, 50))
        self.sbutton = wx.Button(self, -1, label='Load Busy', pos=(20, 90))
        self.Bind(wx.EVT_BUTTON, self.OnStart, self.sbutton)
        self.Bind(wx.EVT_CLOSE, self.OnQuit)
        self.Show()
        self.proc = None

    def OnStart(self, event):
        # for this demonstration Busy is run as an independent process
        self.proc = Popen([sys.executable, 'BusyAnimation.py', 'progress.gif', '100', '2', '65', '-1', \
                                           '#000000', '#ffffff', '800', '600', '260', '150'],).pid
        #                                      bg         fg       x      y      w      h
    def OnQuit(self, event):
        self.Destroy()


if __name__ == '__main__':
    app = wx.App()
    frame = Demo(None)
    app.MainLoop()
